## rdkit 202203.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

project (RDKit)

IF(NOT CMAKE_BUILD_TYPE)
  SET(CMAKE_BUILD_TYPE Release CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)

# Enable CTest
include(CTest)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(CMAKE_MODULE_PATH
    ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/Code/cmake/Modules/")

add_library(rdkit_base INTERFACE)

option(RDK_BUILD_SWIG_WRAPPERS "build the SWIG wrappers" OFF )
option(RDK_BUILD_PYTHON_WRAPPERS "build the standard python wrappers" ON )
option(RDK_BUILD_COMPRESSED_SUPPLIERS "build in support for compressed MolSuppliers" OFF )
option(RDK_BUILD_INCHI_SUPPORT "build the rdkit inchi wrapper" OFF )
option(RDK_BUILD_AVALON_SUPPORT "install support for the avalon toolkit. Use the variable AVALONTOOLS_DIR to set the location of the source." OFF )
option(RDK_BUILD_PGSQL "build the PostgreSQL cartridge" OFF )
option(RDK_BUILD_RPATH_SUPPORT "build shared libraries using rpath" OFF)
option(RDK_PGSQL_STATIC "statically link rdkit libraries into the PostgreSQL cartridge" ON )
option(RDK_BUILD_CONTRIB "build the Contrib directory" OFF )
option(RDK_INSTALL_INTREE "install the rdkit in the source tree (former behavior)" ON )
option(RDK_INSTALL_DLLS_MSVC "install the rdkit DLLs when using MSVC" OFF)
option(RDK_INSTALL_STATIC_LIBS "install the rdkit static libraries" ON )
option(RDK_INSTALL_PYTHON_TESTS "install the rdkit Python tests with the wrappers" OFF )
option(RDK_BUILD_THREADSAFE_SSS "enable thread-safe substructure searching" ON )
option(RDK_BUILD_SLN_SUPPORT "include support for the SLN format" ON )
option(RDK_TEST_MULTITHREADED "run some tests of multithreading" ON )
option(RDK_BUILD_SWIG_JAVA_WRAPPER "build the SWIG JAVA wrappers (does nothing if RDK_BUILD_SWIG_WRAPPERS is not set)" ON )
option(RDK_BUILD_SWIG_CSHARP_WRAPPER "build the experimental SWIG C# wrappers (does nothing if RDK_BUILD_SWIG_WRAPPERS is not set)" OFF )
option(RDK_SWIG_STATIC "statically link rdkit libraries into the SWIG wrappers" ON )
option(RDK_TEST_MMFF_COMPLIANCE "run MMFF compliance tests (requires tar/gzip)" ON )
option(RDK_BUILD_CPP_TESTS "build the c++ tests (disabing can speed up builds" ON)
option(RDK_USE_FLEXBISON "use flex/bison, if available, to build the SMILES/SMARTS/SLN parsers" OFF)
option(RDK_TEST_COVERAGE "Use G(L)COV to compute test coverage" OFF)
option(RDK_USE_BOOST_SERIALIZATION "Use the boost serialization library if available" ON)
option(RDK_USE_BOOST_STACKTRACE "use boost::stacktrace to do more verbose invariant output (linux only)" ON)
option(RDK_BUILD_TEST_GZIP "Build the gzip'd stream test" OFF)
option(RDK_OPTIMIZE_POPCNT "Use SSE4.2 popcount instruction while compiling." ON)
option(RDK_USE_STRICT_ROTOR_DEFINITION "Use the most strict rotatable bond definition" ON)
option(RDK_BUILD_DESCRIPTORS3D "Build the 3D descriptors calculators, requires Eigen3 to be installed" ON)
option(RDK_BUILD_FREESASA_SUPPORT "build the rdkit freesasa wrapper" OFF )
option(RDK_BUILD_COORDGEN_SUPPORT "build the rdkit coordgen wrapper" ON )
option(RDK_BUILD_MAEPARSER_SUPPORT "build the rdkit MAE parser wrapper" ON )
option(RDK_BUILD_MOLINTERCHANGE_SUPPORT "build in support for CommonChem molecule interchange" ON )
option(RDK_BUILD_YAEHMOP_SUPPORT "build support for the YAeHMOP wrapper" OFF)
option(RDK_BUILD_STRUCTCHECKER_SUPPORT "build in support for the StructChecker alpha (not recommended, use the MolVS integration instead)" OFF )
option(RDK_USE_URF "Build support for Florian Flachsenberg's URF library" ON)
option(RDK_INSTALL_DEV_COMPONENT "install libraries and headers" ON)
option(RDK_USE_BOOST_REGEX "use boost::regex instead of std::regex (needed for systems with g++-4.8)" OFF)
option(RDK_USE_BOOST_IOSTREAMS "use boost::iostreams" ON)
option(RDK_BUILD_MINIMAL_LIB "build the minimal RDKit wrapper (for the JS bindings)" OFF)
option(RDK_BUILD_CFFI_LIB "build the CFFI wrapper (for use in other programming languges)" OFF)
option(RDK_BUILD_FUZZ_TARGETS "build the fuzz targets" OFF)

set(RDK_BOOST_VERSION "1.58.0")

if(NOT MSVC)
  if(RDK_OPTIMIZE_POPCNT)
    if(CMAKE_SYSTEM_PROCESSOR STREQUAL "aarch64")
      message("RDK_OPTIMIZE_POPCNT is not available on aarch64")
    elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "^(ppc64|powerpc64)")
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mpopcntd")
    else()
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mpopcnt")
    endif()
  endif()
endif()

if(NOT UNIX OR APPLE)
  if(RDK_USE_BOOST_STACKTRACE)
    MESSAGE("Disabling boost::stacktrace on non-linux platform")
    set(RDK_USE_BOOST_STACKTRACE OFF)
  endif(RDK_USE_BOOST_STACKTRACE)
endif()

if(NOT RDK_BUILD_SWIG_WRAPPERS)
  set(RDK_BUILD_SWIG_JAVA_WRAPPER OFF)
  set(RDK_BUILD_SWIG_CSHARP_WRAPPER OFF)
endif()

if(RDK_SWIG_STATIC AND RDK_BUILD_SWIG_WRAPPERS)
  if(NOT MSVC AND NOT RDK_INSTALL_STATIC_LIBS)
    message("Enabling RDK_INSTALL_STATIC_LIBS because RDK_SWIG_STATIC is set.")
    set(RDK_INSTALL_STATIC_LIBS ON CACHE BOOL "install the rdkit static libraries" FORCE)
  endif(NOT MSVC AND NOT RDK_INSTALL_STATIC_LIBS)
endif()

if((NOT (MSVC AND (NOT RDK_INSTALL_DLLS_MSVC))) AND NOT (WIN32 AND RDK_INSTALL_STATIC_LIBS))
  add_definitions(-DRDKIT_DYN_LINK)
endif()

if(RDK_PGSQL_STATIC AND RDK_BUILD_PGSQL)
  if(NOT MSVC AND NOT RDK_INSTALL_STATIC_LIBS)
    message("Enabling RDK_INSTALL_STATIC_LIBS because RDK_PGSQL_STATIC is set.")
    set(RDK_INSTALL_STATIC_LIBS ON CACHE BOOL "install the rdkit static libraries" FORCE)
  endif(NOT MSVC AND NOT RDK_INSTALL_STATIC_LIBS)
endif()

if(RDK_BUILD_CFFI_LIB)
  if(NOT MSVC AND NOT RDK_INSTALL_STATIC_LIBS)
    message("Enabling RDK_INSTALL_STATIC_LIBS because RDK_BUILD_CFFI_LIB is set.")
    set(RDK_INSTALL_STATIC_LIBS ON CACHE BOOL "install the rdkit static libraries" FORCE)
  endif(NOT MSVC AND NOT RDK_INSTALL_STATIC_LIBS)
endif()


include(TestBigEndian)
TEST_BIG_ENDIAN(RDK_BIG_ENDIAN)

# At build time put runtime binaries in the bin subdirectory
set(RDK_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/bin")
set(RDK_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/lib")
set(RDK_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/lib")
# Also place the python extension where the source tree would expect them
set(RDK_PYTHON_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/rdkit")

#-------
# Config variables:
set(RDKit_Year "2022")
set(RDKit_Month "03")
set(RDKit_Revision "2")
set(RDKit_RevisionModifier "")
set(RDKit_ABI "1")

# we need an integer version of the month later, so remove the zero padding
# if there is any
string(REGEX REPLACE "^0" "" RDKit_intMonth ${RDKit_Month} )

set(RDKit_CodeDir "${CMAKE_CURRENT_SOURCE_DIR}/Code")
set(RDKit_ExternalDir "${CMAKE_CURRENT_SOURCE_DIR}/External")
set(RDKit_DataDir "${CMAKE_CURRENT_SOURCE_DIR}/Data")

#include catch
add_subdirectory(${RDKit_ExternalDir}/catch)
message("CATCH: ${CATCH_INCLUDE_DIR}")

if(RDK_INSTALL_INTREE)
  set(RDKit_BinDir "${CMAKE_SOURCE_DIR}/bin")
  set(RDKit_LibDir "${CMAKE_SOURCE_DIR}/lib")
  set(RDKit_HdrDir "Code") # used in rdkit-config.cmake, path prefix not needed.
  set(RDKit_ShareDir "${CMAKE_SOURCE_DIR}")
else(RDK_INSTALL_INTREE)
  set(RDKit_BinDir "bin")
  set(RDKit_LibDir "lib${LIB_SUFFIX}")
  set(RDKit_HdrDir "include/rdkit")
  set(RDKit_ShareDir "share/RDKit")
endif(RDK_INSTALL_INTREE)

if(RDK_BUILD_RPATH_SUPPORT)
  # use, i.e. don't skip the full RPATH for the build tree
  SET(CMAKE_SKIP_BUILD_RPATH  FALSE)

  # when building, don't use the install RPATH already
  # (but later on when installing)
  SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)

  message("CMAKE_INSTALL_RPATH ${CMAKE_INSTALL_PREFIX}/lib")
  SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")

  # add the automatically determined parts of the RPATH
  # which point to directories outside the build tree to the install RPATH
  SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

  # the RPATH to be used when installing, but only if it's not a system
  # directory
  LIST(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES
  "${CMAKE_INSTALL_PREFIX}/lib" isSystemDir)
  IF("${isSystemDir}" STREQUAL "-1")
     SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
  ENDIF("${isSystemDir}" STREQUAL "-1")
endif()



if(RDK_BUILD_SWIG_WRAPPERS)
  set(RDKit_JavaLibDir "${RDKit_ExternalDir}/java_lib")
endif(RDK_BUILD_SWIG_WRAPPERS)


if(RDK_BUILD_COORDGEN_SUPPORT)
    add_definitions(-DRDK_BUILD_COORDGEN_SUPPORT)
    include_directories(${RDKit_ExternalDir})
endif()

if(RDK_BUILD_MAEPARSER_SUPPORT)
    add_definitions(-DRDK_BUILD_MAEPARSER_SUPPORT)
    include_directories(${RDKit_ExternalDir})
endif()

if(RDK_USE_URF)
  add_definitions(-DRDK_USE_URF)
  if((MSVC AND (NOT RDK_INSTALL_DLLS_MSVC)) OR ((NOT MSVC) AND WIN32 AND RDK_INSTALL_STATIC_LIBS))
    add_definitions(-DRDL_WIN_STATIC)
  endif()
  include_directories(${RDKit_ExternalDir}/RingFamilies/RingDecomposerLib/src/RingDecomposerLib)
endif()


if(CMAKE_SIZEOF_VOID_P EQUAL 4)
  target_compile_definitions(rdkit_base INTERFACE "-DRDK_32BIT_BUILD")
else()
  target_compile_definitions(rdkit_base INTERFACE "-DRDK_64BIT_BUILD")
endif()

if(MINGW)
  target_compile_definitions(rdkit_base INTERFACE "-DBOOST_SYSTEM_NO_DEPRECATED")
endif(MINGW)

# defines macros: rdkit_python_extension, rdkit_test
include(RDKitUtils)

install(TARGETS rdkit_base EXPORT ${RDKit_EXPORTED_TARGETS}
        COMPONENT dev )

# disable some warnings that we don't care about
if(MSVC)
  # These should occasionally be enabled to check what's going on
  # 4267 conversion with possible loss of data.
  # 4305 truncation from 'double' to 'const float'
  # 4244 conversion from 'uint64_t' to 'unsigned int', possible loss of data
  target_compile_options(rdkit_base INTERFACE "/wd4267" "/wd4305" "/wd4244")
  target_compile_definitions(rdkit_base INTERFACE "_CRT_SECURE_NO_WARNINGS")
endif(MSVC)


# extra boost versions
if(MSVC)
  # FIX: do we still need this?
  target_compile_definitions(rdkit_base INTERFACE "-DBOOST_ALL_NO_LIB")
  if(RDK_INSTALL_DLLS_MSVC)
    target_compile_definitions(rdkit_base INTERFACE "-DBOOST_ALL_DYN_LINK")
  endif(RDK_INSTALL_DLLS_MSVC)
endif(MSVC)

if(RDK_BUILD_INCHI_SUPPORT)
  find_package(Inchi)
endif(RDK_BUILD_INCHI_SUPPORT)

if(RDK_BUILD_PYTHON_WRAPPERS)
  add_library(rdkit_py_base INTERFACE)

  #-------
  # pull in python:
  find_package(PythonInterp)
  if (PYTHONINTERP_FOUND AND NOT Python_ADDITIONAL_VERSIONS)
    set(Python_ADDITIONAL_VERSIONS "${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}")
  endif (PYTHONINTERP_FOUND AND NOT Python_ADDITIONAL_VERSIONS)

  if(PYTHON_VERSION_MAJOR EQUAL 2)
    message(FATAL_ERROR "ERROR: The RDKit no longer supports Python 2.\nIf you have Python 3 installed, you can tell cmake where to find it using the -DPYTHON_EXECUTABLE argument.")
  endif()

  find_package(PythonLibs)
  target_include_directories(rdkit_base INTERFACE ${PYTHON_INCLUDE_DIR})

  # determine linkage of python
  execute_process(
      COMMAND
      ${PYTHON_EXECUTABLE} -c "from distutils import sysconfig; print(sysconfig.get_config_var('Py_ENABLE_SHARED'))"
      OUTPUT_VARIABLE Py_ENABLE_SHARED
      OUTPUT_STRIP_TRAILING_WHITESPACE
  )

  if(WIN32 OR "${Py_ENABLE_SHARED}" STREQUAL "1")
    target_link_libraries(rdkit_py_base INTERFACE ${PYTHON_LIBRARIES} )
  endif()
  
  find_package(NumPy REQUIRED)
  target_include_directories(rdkit_base INTERFACE ${PYTHON_NUMPY_INCLUDE_PATH})

  if(PYTHON_VERSION_MAJOR EQUAL 3)
    # Find boost-python3 using name specified as command line option then fall back to commonly used names
    set(RDK_BOOST_PYTHON3_NAME "python3" CACHE STRING "Name of the boost python3 library. If installed as libboost_python-xxx.so, use python-xxx.")
    list(APPEND Boost_Python_Names "${RDK_BOOST_PYTHON3_NAME}" "python-py3${PYTHON_VERSION_MINOR}" "python3")
  endif(PYTHON_VERSION_MAJOR EQUAL 3)

  # Boost 1.67+ uses a version suffix like "python36" or "python27"

=== Code/GraphMol/CMakeLists.txt ===

rdkit_library(GraphMol
              Atom.cpp QueryAtom.cpp QueryBond.cpp Bond.cpp
              MolOps.cpp FindRings.cpp ROMol.cpp RWMol.cpp PeriodicTable.cpp
              atomic_data.cpp QueryOps.cpp MolPickler.cpp Canon.cpp
              AtomIterators.cpp BondIterators.cpp Aromaticity.cpp Kekulize.cpp
              ConjugHybrid.cpp AddHs.cpp
              Matrices.cpp Chirality.cpp RingInfo.cpp Conformer.cpp
              Renumber.cpp AdjustQuery.cpp Resonance.cpp StereoGroup.cpp
              new_canon.cpp SubstanceGroup.cpp FindStereo.cpp MonomerInfo.cpp
              SHARED
              LINK_LIBRARIES RDGeometryLib RDGeneral  )
target_compile_definitions(GraphMol PRIVATE RDKIT_GRAPHMOL_BUILD)
if(RDK_USE_URF)
  target_link_libraries(GraphMol PUBLIC ${RDK_URF_LIBS})
  if(NOT WIN32 AND RDK_INSTALL_STATIC_LIBS)
    target_link_libraries(GraphMol_static PUBLIC ${RDK_URF_LIBS}_static)
  endif()
endif()

rdkit_headers(Atom.h
              atomic_data.h
              AtomIterators.h
              Bond.h
              BondIterators.h
              Canon.h
              Chirality.h
              Conformer.h
              details.h
              GraphMol.h
              MolOps.h
              MolPickler.h
              PeriodicTable.h
              QueryAtom.h
              QueryBond.h
              QueryOps.h
              RDKitBase.h
              RDKitQueries.h
              Resonance.h
              RingInfo.h
              Rings.h
              ROMol.h
              RWMol.h
              SanitException.h
              SubstanceGroup.h
              StereoGroup.h
              MonomerInfo.h
              new_canon.h
              MolBundle.h
              DEST GraphMol)

add_subdirectory(Depictor)
add_subdirectory(SmilesParse)
add_subdirectory(FileParsers)
add_subdirectory(Substruct)
add_subdirectory(GenericGroups)
add_subdirectory(ChemReactions)
add_subdirectory(ChemTransforms)
add_subdirectory(TautomerQuery)

add_subdirectory(Subgraphs)
add_subdirectory(FilterCatalog)
add_subdirectory(FragCatalog)
add_subdirectory(Descriptors)

add_subdirectory(Fingerprints)
add_subdirectory(PartialCharges)

add_subdirectory(MolTransforms)
add_subdirectory(ForceFieldHelpers)
add_subdirectory(DistGeomHelpers)

add_subdirectory(MolAlign)
add_subdirectory(MolChemicalFeatures)
add_subdirectory(ShapeHelpers)
add_subdirectory(MolCatalog)

add_subdirectory(MolDraw2D)

add_subdirectory(FMCS)
add_subdirectory(MolHash)
add_subdirectory(MMPA)

add_subdirectory(CIPLabeler)
add_subdirectory(Deprotect)

if(RDK_BUILD_STRUCTCHECKER_SUPPORT)
add_subdirectory(StructChecker)
endif()

add_subdirectory(ReducedGraphs)
add_subdirectory(Trajectory)

add_subdirectory(SubstructLibrary)
add_subdirectory(RGroupDecomposition)

if(RDK_BUILD_MOLINTERCHANGE_SUPPORT)
add_subdirectory(MolInterchange)
endif(RDK_BUILD_MOLINTERCHANGE_SUPPORT)

if(RDK_BUILD_SLN_SUPPORT AND NOT CMAKE_COMPILER_IS_CLANG)
  if(CMAKE_COMPILER_IS_GNUCC AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS_EQUAL 4.8)
    message("Skipping SLN build with gcc version <= 4.8")
  else()
    add_subdirectory(SLNParse)
  endif()
endif()

if(RDK_BUILD_PYTHON_WRAPPERS)
add_subdirectory(Wrap)
endif()

add_subdirectory(MolStandardize)
add_subdirectory(ScaffoldNetwork)
add_subdirectory(MolEnumerator)
add_subdirectory(Abbreviations)


rdkit_test(graphmolTest1 test1.cpp LINK_LIBRARIES FileParsers SmilesParse GraphMol
 SubstructMatch ForceFieldHelpers ForceField)

rdkit_test(graphmolcpTest cptest.cpp LINK_LIBRARIES  SmilesParse GraphMol)

rdkit_test(graphmolqueryTest querytest.cpp LINK_LIBRARIES SubstructMatch SmilesParse GraphMol)

rdkit_test(graphmolMolOpsTest molopstest.cpp
           LINK_LIBRARIES SubstructMatch FileParsers
	   SmilesParse GraphMol )

rdkit_test(graphmoltestChirality testChirality.cpp
           LINK_LIBRARIES SmilesParse FileParsers
	   GraphMol )

rdkit_test(graphmoltestPickler testPickler.cpp
           LINK_LIBRARIES SmilesParse SubstructMatch FileParsers GraphMol )

rdkit_test(graphmoltestPicklerGlobalSetting testPicklerGlobalSettings.cpp
           LINK_LIBRARIES SmilesParse SubstructMatch FileParsers GraphMol )

rdkit_test(graphmolIterTest itertest.cpp LINK_LIBRARIES SmilesParse GraphMol )

rdkit_test(hanoiTest hanoitest.cpp LINK_LIBRARIES
     SubstructMatch SmilesParse FileParsers GraphMol
      )

rdkit_test(graphmolMemTest1 memtest1.cpp LINK_LIBRARIES SmilesParse GraphMol )

rdkit_test(resMolSupplierTest resMolSupplierTest.cpp
           LINK_LIBRARIES SmilesParse GraphMol SubstructMatch FileParsers)

rdkit_test(molBundleTest testMolBundle.cpp
          LINK_LIBRARIES SmilesParse GraphMol SubstructMatch FileParsers)

rdkit_test(testSGroup testSGroup.cpp LINK_LIBRARIES FileParsers GraphMol)

rdkit_test(test-valgrind test-valgrind.cpp LINK_LIBRARIES SmilesParse GraphMol )

rdkit_catch_test(graphmolTestsCatch catch_graphmol.cpp catch_main.cpp
           LINK_LIBRARIES SubstructMatch FileParsers SmilesParse GraphMol )

rdkit_catch_test(graphmolSGroupCatch catch_sgroups.cpp  catch_main.cpp
           LINK_LIBRARIES SmilesParse FileParsers GraphMol )

rdkit_catch_test(graphmolAdjustQueryCatch catch_adjustquery.cpp catch_main.cpp
           LINK_LIBRARIES SubstructMatch FileParsers SmilesParse GraphMol )
           
rdkit_catch_test(chiralityTestsCatch catch_chirality.cpp catch_main.cpp
           LINK_LIBRARIES FileParsers SmilesParse GraphMol )

rdkit_catch_test(moliteratorTestsCatch catch_moliterators.cpp catch_main.cpp
           LINK_LIBRARIES SubstructMatch SmilesParse GraphMol )

=== Code/RDGeneral/CMakeLists.txt ===
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/versions.cpp.cmake
               ${CMAKE_CURRENT_SOURCE_DIR}/versions.cpp )
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/versions.h.cmake
               ${CMAKE_CURRENT_SOURCE_DIR}/versions.h )
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/RDConfig.h.cmake
              ${CMAKE_CURRENT_SOURCE_DIR}/RDConfig.h )


rdkit_library(RDGeneral
              Invariant.cpp types.cpp utils.cpp RDGeneralExceptions.cpp RDLog.cpp
              LocaleSwitcher.cpp versions.cpp SHARED)
target_compile_definitions(RDGeneral PRIVATE RDKIT_RDGENERAL_BUILD)

if(MINGW)
  set(hasMSVCRuntime "FALSE")
  if(RDK_BUILD_THREADSAFE_SSS)
    set(needMSVCRuntime "TRUE")
  else()
    set(needMSVCRuntime "FALSE")
  endif()
  if(needMSVCRuntime AND MSVC_RUNTIME_DLL)
    if(EXISTS "${MSVC_RUNTIME_DLL}")
      set(hasMSVCRuntime "TRUE")
    endif()
  endif()
  if(needMSVCRuntime AND (NOT hasMSVCRuntime))
    set(systemRootPath "$ENV{SystemRoot}")
    string(REGEX REPLACE "\\\\" "/" systemRootPath "${systemRootPath}")
    message(FATAL_ERROR "Please set MSVC_RUNTIME_DLL to the full path to a msvcrXXX.dll "
      "Microsoft Visual C Runtime DLL appropriate for your system; the most likely path is "
      "${systemRootPath}/System32, or ${systemRootPath}/SysWOW64 in case you are building "
      "32-bit RDKit under a 64-bit Windows OS.")
  endif()
endif(MINGW)

if(RDK_USE_BOOST_STACKTRACE AND UNIX AND NOT APPLE)
set(EXTRA_STACKTRACE_LIBS dl)
endif()

target_link_libraries(RDGeneral PUBLIC ${RDKit_THREAD_LIBS} ${MSVC_RUNTIME_DLL} ${EXTRA_STACKTRACE_LIBS})


rdkit_headers(Exceptions.h
              BadFileException.h
              BoostStartInclude.h
              BoostEndInclude.h
              Dict.h
              FileParseException.h
              Invariant.h
              RDAny.h
              RDValue.h
              RDValue-doublemagic.h
              RDValue-taggedunion.h
              RDLog.h
              RDProps.h
              RDThreads.h
              StreamOps.h
              types.h
              utils.h
              versions.h
              RDConfig.h
              LocaleSwitcher.h
              Ranking.h
              hanoiSort.h
              RDExportMacros.h
              export.h
              test.h
              ConcurrentQueue.h
              DEST RDGeneral)

if (NOT RDK_INSTALL_INTREE)
  install(DIRECTORY hash DESTINATION ${RDKit_HdrDir}/RDGeneral)
endif (NOT RDK_INSTALL_INTREE)

rdkit_test(testDict testDict.cpp LINK_LIBRARIES RDGeneral)
rdkit_test(testRDValue testRDValue.cpp LINK_LIBRARIES RDGeneral)

if(RDK_BUILD_THREADSAFE_SSS)
rdkit_test(testConcurrentQueue testConcurrentQueue.cpp LINK_LIBRARIES RDGeneral)
endif(RDK_BUILD_THREADSAFE_SSS)

rdkit_catch_test(dictTestsCatch catch_dict.cpp catch_main.cpp
           LINK_LIBRARIES RDGeneral )

rdkit_catch_test(logTestsCatch catch_logs.cpp catch_main.cpp
           LINK_LIBRARIES RDGeneral )

=== External/AvalonTools/CMakeLists.txt ===
if(NOT RDK_BUILD_AVALON_SUPPORT)
  return()
endif(NOT RDK_BUILD_AVALON_SUPPORT)

if(NOT DEFINED AVALONTOOLS_DIR)
  set(AVALONTOOLS_DIR "${CMAKE_CURRENT_SOURCE_DIR}/SourceDistribution")
  set(fileToPatch "${CMAKE_CURRENT_SOURCE_DIR}/SourceDistribution/common/reaccsio.c")
  set(needDownload "TRUE")
  if(EXISTS "${fileToPatch}")
    file(READ "${fileToPatch}" buffer)
    if("${buffer}" MATCHES "//MyFree\\(\\(char \\*\\)tempdir\\);")
      set(needDownload "FALSE")
    endif()
  endif()
else()
  string(REGEX REPLACE "\\\\" "/" AVALONTOOLS_DIR ${AVALONTOOLS_DIR})
  set(needDownload "FALSE")
endif()

set(AVALON_SRC_PATH ${AVALONTOOLS_DIR}/common)

if(needDownload)
  if(NOT DEFINED AVALONTOOLS_URL)
    set(AVALONTOOLS_URL "https://sourceforge.net/projects/avalontoolkit/files/AvalonToolkit_1.2/AvalonToolkit_1.2.0.source.tar")
  endif()
  if(NOT DEFINED AVALONTOOLS_MD5SUM)
    set(AVALONTOOLS_MD5SUM "092a94f421873f038aa67d4a6cc8cb54")
  endif()
  if(NOT DEFINED AVALONTOOLS_BASE)
    string(REGEX REPLACE "^.*/" "" AVALONTOOLS_BASE "${AVALONTOOLS_URL}")
  endif()
  downloadAndCheckMD5(${AVALONTOOLS_URL} "${CMAKE_CURRENT_SOURCE_DIR}/${AVALONTOOLS_BASE}" ${AVALONTOOLS_MD5SUM})
  execute_process(COMMAND ${CMAKE_COMMAND} -E tar xf
    ${CMAKE_CURRENT_SOURCE_DIR}/AvalonToolkit_1.2.0.source.tar
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
  # apply patch to AvalonTools
  configure_file("${fileToPatch}" "${fileToPatch}.orig" COPYONLY)
  file(READ "${fileToPatch}" buffer)
  string(REGEX REPLACE "MyFree\\(\\(char \\*\\)tempdir\\);"
    "//MyFree((char *)tempdir);" buffer "${buffer}")
  file(WRITE "${fileToPatch}" "${buffer}")
endif()

if (MSVC)
  add_definitions("/D_CRT_SECURE_NO_WARNINGS")
  add_compile_options(/wd4224 /wd4101 /wd4018 /wd4996 /wd4244 /wd4305 /wd4013 /wd4146 /wd4334 /wd4715 /wd4715 /nologo)
endif(MSVC)

set(avalon_clib_srcs ${AVALON_SRC_PATH}/layout.c
	${AVALON_SRC_PATH}/symboltable.c
	${AVALON_SRC_PATH}/patclean.c
	${AVALON_SRC_PATH}/utilities.c
	${AVALON_SRC_PATH}/symbol_lists.c
	${AVALON_SRC_PATH}/stereo.c
	${AVALON_SRC_PATH}/set.c
	${AVALON_SRC_PATH}/perceive.c
	${AVALON_SRC_PATH}/local.c
	${AVALON_SRC_PATH}/graph.c
	${AVALON_SRC_PATH}/geometry.c
	${AVALON_SRC_PATH}/forio.c
	${AVALON_SRC_PATH}/depictutil.c
	${AVALON_SRC_PATH}/denormal.c
	${AVALON_SRC_PATH}/casutils.c
	${AVALON_SRC_PATH}/ssmatch.c
	${AVALON_SRC_PATH}/rtutils.c
	${AVALON_SRC_PATH}/smi2mol.c
	${AVALON_SRC_PATH}/didepict.c
	${AVALON_SRC_PATH}/pattern.c
	${AVALON_SRC_PATH}/canonizer.c
	${AVALON_SRC_PATH}/aacheck.c
	${AVALON_SRC_PATH}/fixcharges.c
	${AVALON_SRC_PATH}/struchk.c
	${AVALON_SRC_PATH}/reaccsio.c
	${AVALON_SRC_PATH}/hashcode.c
  )

# we need this to ensure that builds continue
# to work on linux systems with older versions
# of glibc when we're building with gcc-4.1.
# Without this flag, we'll endup requiring
# glibc 2.7.
if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
    add_definitions(-D_GNU_SOURCE=1)
endif()

if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-return-type -Wno-implicit-function-declaration -Wno-absolute-value -Wno-parentheses -Wno-logical-op-parentheses -Wno-dangling-else -Wno-format")
endif()
if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-unused-result -Wformat-overflow=0 -Wformat=0 -Wno-format-security -Wno-implicit-function-declaration")
endif()



rdkit_library(avalon_clib ${avalon_clib_srcs})
target_compile_definitions(avalon_clib PRIVATE RDKIT_AVALONLIB_BUILD)
if((MSVC AND RDK_INSTALL_DLLS_MSVC) OR ((NOT MSVC) AND WIN32))
  set_target_properties(avalon_clib PROPERTIES WINDOWS_EXPORT_ALL_SYMBOLS TRUE)
endif()

include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${AVALON_SRC_PATH})

rdkit_library(AvalonLib AvalonTools.cpp SHARED 
     LINK_LIBRARIES avalon_clib SubstructMatch FileParsers SmilesParse GraphMol DataStructs  )
target_compile_definitions(AvalonLib PRIVATE RDKIT_AVALONLIB_BUILD)
rdkit_headers(AvalonTools.h DEST GraphMol)
rdkit_test(testAvalonLib1 test1.cpp
           LINK_LIBRARIES AvalonLib SubstructMatch )

if(RDK_BUILD_PYTHON_WRAPPERS)
add_subdirectory(Wrap)
endif()

=== Code/GraphMol/CIPLabeler/CMakeLists.txt ===

set(configs_src
    configs/Configuration.cpp
    configs/Sp2Bond.cpp
    configs/Tetrahedral.cpp)

set(rules_src
    rules/Rule1a.cpp
    rules/Rule1b.cpp
    rules/Rule2.cpp
    rules/Rule3.cpp
    rules/Rule4a.cpp
    rules/Rule4b.cpp
    rules/Rule4c.cpp
    rules/Rule5.cpp
    rules/Rule5New.cpp
    rules/Rule6.cpp
    rules/SequenceRule.cpp)

rdkit_library(CIPLabeler
              CIPMol.cpp CIPLabeler.cpp
              Mancude.cpp Digraph.cpp Node.cpp Edge.cpp Sort.cpp
              ${configs_src} ${rules_src}
              LINK_LIBRARIES GraphMol)
target_compile_definitions(CIPLabeler PRIVATE RDKIT_CIPLABELER_BUILD)

rdkit_headers(CIPLabeler.h
              TooManyNodesException.h
              DEST CIPLabeler)

rdkit_catch_test(testCIPLabeler catch_tests.cpp ../catch_main.cpp
                 CIPMol.cpp CIPLabeler.cpp
                 Mancude.cpp Digraph.cpp Node.cpp Edge.cpp Sort.cpp
                 ${configs_src} ${rules_src}
                 LINK_LIBRARIES SmilesParse GraphMol)

# Set the BUILD macro to keep dll linkage consistency, since, in order
# to test private, unexported functions, we are building the test from
# sources, and NOT linking to the lib.
if(RDK_BUILD_CPP_TESTS)
    target_compile_definitions(testCIPLabeler PRIVATE RDKIT_CIPLABELER_BUILD)
endif()

if(RDK_BUILD_PYTHON_WRAPPERS)
add_subdirectory(Wrap)
endif()

=== Code/GraphMol/ChemTransforms/CMakeLists.txt ===

rdkit_library(ChemTransforms ChemTransforms.cpp MolFragmenter.cpp LINK_LIBRARIES
  GraphMol SubstructMatch SmilesParse )
target_compile_definitions(ChemTransforms PRIVATE -DRDKIT_CHEMTRANSFORMS_BUILD)

rdkit_headers(ChemTransforms.h
   MolFragmenter.h
   DEST GraphMol/ChemTransforms)

# there's no Wrap subdirectory on the main trunk (but in "minimal" there is)..
#add_subdirectory(Wrap)

rdkit_test(testChemTransforms testChemTransforms.cpp 
           LINK_LIBRARIES ChemTransforms FileParsers)

rdkit_catch_test(chemTransformsTestCatch ../catch_main.cpp catch_tests.cpp LINK_LIBRARIES ChemTransforms FileParsers)

=== Code/GraphMol/Depictor/CMakeLists.txt ===

remove_definitions(-DRDKIT_GRAPHMOL_BUILD)

if(RDK_BUILD_COORDGEN_SUPPORT)

    if(MSVC AND (NOT RDK_INSTALL_DLLS_MSVC))
      add_definitions(-DSTATIC_COORDGEN)
    else(MSVC AND (NOT RDK_INSTALL_DLLS_MSVC))
      add_definitions(-DIN_COORDGEN)
    endif(MSVC AND (NOT RDK_INSTALL_DLLS_MSVC))

    include_directories(${coordgen_INCLUDE_DIRS})
endif()

rdkit_library(Depictor
              RDDepictor.cpp EmbeddedFrag.cpp DepictUtils.cpp
              LINK_LIBRARIES ${RDK_COORDGEN_LIBS} SubstructMatch MolTransforms GraphMol RDGeneral)
target_compile_definitions(Depictor PRIVATE RDKIT_DEPICTOR_BUILD)

rdkit_headers(DepictUtils.h
              EmbeddedFrag.h
              RDDepictor.h DEST GraphMol/Depictor)

rdkit_test(testDepictor testDepictor.cpp
           LINK_LIBRARIES Depictor ChemTransforms FileParsers SmilesParse )

FILE(GLOB TEST_OUTPUT_FILES "${CMAKE_CURRENT_SOURCE_DIR}/test_data/*.out.sdf")
get_directory_property(extra_clean_files ADDITIONAL_MAKE_CLEAN_FILES)
set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES
        "${extra_clean_files};${TEST_OUTPUT_FILES}")


rdkit_catch_test(depictorCatch catch_tests.cpp ../catch_main.cpp LINK_LIBRARIES Depictor SmilesParse FileParsers )


if(RDK_BUILD_PYTHON_WRAPPERS)
add_subdirectory(Wrap)
endif()

=== Code/GraphMol/FileParsers/CMakeLists.txt ===


if(RDK_USE_BOOST_IOSTREAMS)
if(WIN32)
  find_package(Boost ${RDK_BOOST_VERSION} COMPONENTS system iostreams REQUIRED)
  set (link_iostreams ${Boost_LIBRARIES})
  if (NOT Boost_USE_STATIC_LIBS)
     add_definitions("-DBOOST_IOSTREAMS_DYN_LINK")
  endif()
  find_package(ZLIB)
  include_directories(${ZLIB_INCLUDE_DIRS})
  find_package(Boost ${RDK_BOOST_VERSION} COMPONENTS zlib)
  if(Boost_zlib_FOUND)
    set(zlib_lib Boost::zlib)
  else()
    set(zlib_lib ${ZLIB_LIBRARIES})
  endif()


else()
  find_package(Boost ${RDK_BOOST_VERSION} COMPONENTS system iostreams REQUIRED)
  set (link_iostreams ${Boost_LIBRARIES})
  if (NOT Boost_USE_STATIC_LIBS)
     add_definitions("-DBOOST_IOSTREAMS_DYN_LINK")
  endif()
  find_package(ZLIB)
  include_directories(${ZLIB_INCLUDE_DIRS})
  set(zlib_lib ${ZLIB_LIBRARIES})
endif()
ADD_DEFINITIONS("-DRDK_USE_BOOST_IOSTREAMS")
endif(RDK_USE_BOOST_IOSTREAMS)

if(RDK_BUILD_MAEPARSER_SUPPORT)
    include_directories(${maeparser_INCLUDE_DIRS})
    set (maesupplier MaeMolSupplier.cpp)
endif()

if(RDK_USE_BOOST_REGEX)
  add_definitions(-DRDKIT_USE_BOOST_REGEX)
  find_package(Boost ${RDK_BOOST_VERSION} COMPONENTS regex REQUIRED)
  set(regex_lib Boost::regex)
endif()

rdkit_library(FileParsers
              Mol2FileParser.cpp MolFileParser.cpp
              MolSGroupParsing.cpp MolSGroupWriting.cpp
              MolFileStereochem.cpp MolFileWriter.cpp
              ForwardSDMolSupplier.cpp SDMolSupplier.cpp SDWriter.cpp
              SmilesMolSupplier.cpp SmilesWriter.cpp
              TDTMolSupplier.cpp TDTWriter.cpp
              TplFileParser.cpp TplFileWriter.cpp
              PDBParser.cpp PDBWriter.cpp PDBSupplier.cpp
              CMLWriter.cpp XYZFileWriter.cpp
              ${maesupplier}
              ProximityBonds.cpp
              SequenceParsers.cpp SequenceWriters.cpp
              SVGParser.cpp PNGParser.cpp
							MultithreadedMolSupplier.cpp
							MultithreadedSmilesMolSupplier.cpp
							MultithreadedSDMolSupplier.cpp
              LINK_LIBRARIES GenericGroups Depictor SmilesParse GraphMol ${RDK_MAEPARSER_LIBS} ${regex_lib} ${link_iostreams} ${zlib_lib})
target_compile_definitions(FileParsers PRIVATE RDKIT_FILEPARSERS_BUILD)

rdkit_headers(FileParsers.h
              FileParserUtils.h
              MolFileStereochem.h
              MolSupplier.h
              MolWriters.h
              SequenceParsers.h SequenceWriters.h
              GeneralFileReader.h
							MultithreadedMolSupplier.h
							MultithreadedSmilesMolSupplier.h
							MultithreadedSDMolSupplier.h
              PNGParser.h
              DEST GraphMol/FileParsers)

rdkit_test(fileParsersTest1 test1.cpp
           LINK_LIBRARIES FileParsers SubstructMatch )



rdkit_test(testMolSupplier testMolSupplier.cpp
           LINK_LIBRARIES  FileParsers RDStreams)

rdkit_test(testGeneralFileReader testGeneralFileReader.cpp
					LINK_LIBRARIES FileParsers RDStreams)

if(RDK_TEST_MULTITHREADED)
rdkit_test(testMultithreadedMolSupplier testMultithreadedMolSupplier.cpp
					LINK_LIBRARIES FileParsers Fingerprints RDStreams)
endif(RDK_TEST_MULTITHREADED)

rdkit_test(testMolWriter testMolWriter.cpp LINK_LIBRARIES FileParsers )

rdkit_test(testTplParser testTpls.cpp LINK_LIBRARIES FileParsers )

rdkit_test(testMol2ToMol testMol2ToMol.cpp LINK_LIBRARIES FileParsers )

rdkit_test(testSequence testSequence.cpp LINK_LIBRARIES FileParsers )

rdkit_test(testExtendedStereoParsing testExtendedStereoParsing.cpp
           LINK_LIBRARIES FileParsers )

rdkit_catch_test(fileParsersCatchTest file_parsers_catch.cpp catch_main.cpp 
           LINK_LIBRARIES FileParsers )

rdkit_catch_test(testPropertyLists testPropertyLists.cpp catch_main.cpp 
           LINK_LIBRARIES FileParsers )

=== Code/GraphMol/GenericGroups/CMakeLists.txt ===

rdkit_library(GenericGroups 
              GenericGroups.cpp 
              LINK_LIBRARIES GraphMol RDGeneral)
target_compile_definitions(GenericGroups PRIVATE RDKIT_GENERICGROUPS_BUILD)

rdkit_headers(GenericGroups.h DEST GraphMol/GenericGroups)

rdkit_catch_test(testGenericGroups ../catch_main.cpp generic_tests.cpp LINK_LIBRARIES GenericGroups FileParsers SmilesParse SubstructMatch)

=== Code/GraphMol/MolDraw2D/CMakeLists.txt ===

option(RDK_BUILD_QT_SUPPORT "build support for QT drawing" OFF )
option(RDK_BUILD_QT_DEMO "build the QT drawing demo" OFF )
option(RDK_BUILD_CAIRO_SUPPORT "build support for Cairo drawing" OFF )
option(RDK_BUILD_FREETYPE_SUPPORT "build support for FreeType font handling" ON)
option(RDK_INSTALL_COMIC_FONTS "download and install comic-neue to maximize the \"utility\" of the comic mode in MolDraw2D" ON)

if(RDK_BUILD_FREETYPE_SUPPORT AND RDK_INSTALL_COMIC_FONTS)
  set(needDownload "TRUE")
  if(EXISTS "${RDKit_DataDir}/Fonts/ComicNeue-Regular.ttf")
    message("${RDKit_DataDir}/Fonts/ComicNeue-Regular.ttf already there, skipping the download")
    set(needDownload "FALSE")
  endif()
  if(needDownload)
    set(MD5Sum "850b0df852f1cda4970887b540f8f333")
    downloadAndCheckMD5("https://fonts.google.com/download?family=Comic%20Neue"
          "${CMAKE_CURRENT_SOURCE_DIR}/Comic_Neue.zip"
          ${MD5Sum})
    execute_process(COMMAND ${CMAKE_COMMAND} -E tar x
      ${CMAKE_CURRENT_SOURCE_DIR}/Comic_Neue.zip --format=zip
      WORKING_DIRECTORY ${RDKit_DataDir}/Fonts)
  endif(needDownload)
endif()

rdkit_headers(MolDraw2D.h
  MolDraw2DSVG.h
  MolDraw2Dwx.h
  MolDraw2DJS.h
  MolDraw2DUtils.h
  MolDraw2DHelpers.h
  DEST GraphMol/MolDraw2D
)

rdkit_library(MolDraw2D MolDraw2D.cpp MolDraw2DSVG.cpp
  MolDraw2DDetails.cpp MolDraw2DUtils.cpp AtomSymbol.cpp
  DrawAnnotation.cpp DrawMol.cpp DrawMolMCH.cpp
  DrawShape.cpp DrawText.cpp DrawTextNotFT.cpp DrawTextSVG.cpp
  MolDraw2DJS.cpp DrawTextJS.cpp
  LINK_LIBRARIES
  ChemReactions Depictor MolTransforms 
  SubstructMatch Subgraphs GraphMol EigenSolvers )
target_compile_definitions(MolDraw2D PRIVATE RDKIT_MOLDRAW2D_BUILD)

# if(RDK_BUILD_QT_DEMO && !RDK_BUILD_QT_SUPPORT) error
if(RDK_BUILD_QT_SUPPORT)
  add_subdirectory(Qt)
endif(RDK_BUILD_QT_SUPPORT)

if(RDK_BUILD_CAIRO_SUPPORT)
  find_package(Cairo REQUIRED)
  target_compile_definitions(MolDraw2D PUBLIC "-DRDK_BUILD_CAIRO_SUPPORT")
  target_link_libraries(MolDraw2D PUBLIC Cairo::Cairo)
  target_sources(MolDraw2D PRIVATE MolDraw2DCairo.cpp DrawTextCairo.cpp)
  if(RDK_INSTALL_STATIC_LIBS AND NOT WIN32)
     target_compile_definitions(MolDraw2D_static PUBLIC "-DRDK_BUILD_CAIRO_SUPPORT")
     target_link_libraries(MolDraw2D_static PUBLIC Cairo::Cairo)
     target_sources(MolDraw2D_static PRIVATE MolDraw2DCairo.cpp DrawTextCairo.cpp)
  endif()
  rdkit_headers(MolDraw2DCairo.h DEST GraphMol/MolDraw2D)
endif(RDK_BUILD_CAIRO_SUPPORT)

if(RDK_BUILD_FREETYPE_SUPPORT)
  target_compile_definitions(MolDraw2D PUBLIC "-DRDK_BUILD_FREETYPE_SUPPORT")
  target_sources(MolDraw2D PRIVATE DrawText.cpp
          DrawTextFT.cpp DrawTextFTSVG.cpp DrawTextFTJS.cpp)
  if(RDK_INSTALL_STATIC_LIBS AND NOT WIN32)
    target_compile_definitions(MolDraw2D_static PUBLIC "-DRDK_BUILD_FREETYPE_SUPPORT")
    target_sources(MolDraw2D_static PRIVATE DrawText.cpp
          DrawTextFT.cpp DrawTextFTSVG.cpp DrawTextFTJS.cpp)
  endif()
  if( ${CMAKE_SYSTEM_NAME} MATCHES "Emscripten")
      set(USE_FLAGS "-s USE_FREETYPE=1")
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${USE_FLAGS}")
      set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${USE_FLAGS}")
      target_link_libraries(MolDraw2D PUBLIC ${FREETYPE_LIBRARIES})
      if(RDK_INSTALL_STATIC_LIBS AND NOT WIN32)
        target_link_libraries(MolDraw2D_static PUBLIC ${FREETYPE_LIBRARIES})
      endif()
  else()
      find_package(Freetype REQUIRED)
      target_link_libraries(MolDraw2D PUBLIC Freetype::Freetype)
      if(RDK_INSTALL_STATIC_LIBS AND NOT WIN32)
        target_link_libraries(MolDraw2D_static PUBLIC Freetype::Freetype)
      endif()
  endif()
  if(RDK_BUILD_CAIRO_SUPPORT)
    target_sources(MolDraw2D PRIVATE DrawTextFTCairo.cpp)
    if(RDK_INSTALL_STATIC_LIBS AND NOT WIN32)
      target_sources(MolDraw2D_static PRIVATE DrawTextFTCairo.cpp)
    endif()
  endif()
endif(RDK_BUILD_FREETYPE_SUPPORT)

rdkit_test(moldraw2DTest1 test1.cpp LINK_LIBRARIES
  MolDraw2D )

rdkit_catch_test(moldraw2DTestCatch ../catch_main.cpp catch_tests.cpp LINK_LIBRARIES
  MolDraw2D CIPLabeler )

rdkit_test(moldraw2DRxnTest1 rxn_test1.cpp LINK_LIBRARIES
  MolDraw2D )

  if(RDK_BUILD_PYTHON_WRAPPERS)
add_subdirectory(Wrap)
endif()

=== Code/GraphMol/MolHash/CMakeLists.txt ===

rdkit_library(MolHash
              hashfunctions.cpp normalize.cpp
              LINK_LIBRARIES Depictor Descriptors GraphMol)
target_compile_definitions(MolHash PRIVATE RDKIT_MOLHASH_BUILD)

rdkit_headers(MolHash.h nmmolhash.h           
              DEST GraphMol/MolHash)

rdkit_catch_test(molHashCatchTest ../catch_main.cpp catch_tests.cpp  LINK_LIBRARIES MolHash)

if(RDK_BUILD_PYTHON_WRAPPERS)
add_subdirectory(Wrap)
endif()

=== Code/GraphMol/Substruct/CMakeLists.txt ===

rdkit_library(SubstructMatch 
              SubstructMatch.cpp SubstructUtils.cpp 
              LINK_LIBRARIES GenericGroups GraphMol RDGeneral)
target_compile_definitions(SubstructMatch PRIVATE RDKIT_SUBSTRUCTMATCH_BUILD)

rdkit_headers(SubstructMatch.h
              SubstructUtils.h DEST GraphMol/Substruct)

rdkit_test(testSubstructMatch test1.cpp LINK_LIBRARIES FileParsers SmilesParse SubstructMatch)

rdkit_catch_test(substructTestCatch ../catch_main.cpp catch_tests.cpp LINK_LIBRARIES FileParsers SmilesParse SubstructMatch)

=== debian/changelog ===
rdkit (202203.2-1.pgdg+1) sid-pgdg; urgency=medium

  * Rebuild for sid-pgdg.
  * No source changes.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Wed, 27 Apr 2022 10:49:49 +0200

rdkit (202203.2-1) unstable; urgency=medium

  * Team upload.

  [ Debichem Team ]
  * New upstream release.

  [ Michael Banck ]
  * debian/patches/postgres_disable_failing_tests.patch: Removed, no longer
    needed.
  * debian/patches/postgres_compile_fixes.patch: Refreshed.

  [ Christoph Berg ]
  * debian/patches/extra_float_digits: Set e_f_t=0 in bfpgin test.
  * debian/salsa-ci.yml: Set DEB_BUILD_OPTIONS: noautodbgsym to fit in Salsa's
    maximum artifact size.
  * debian/source/lintian-overrides: Override source-is-missing
    Code/Demos/RDKit/Draw/draw.html.
  * debian/clean: Remove some generated Code/RDGeneral/*.h files.
  * debian/clean: Remove .gitattributes.

 -- Christoph Berg <myon@debian.org>  Wed, 27 Apr 2022 10:49:49 +0200

=== debian/control ===
Source: rdkit
Section: science
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>
Build-Depends: bison,
               catch2,
               cmake,
               debhelper (>> 9),
               dh-python,
               doxygen,
               flex,
               imagemagick,
               latexmk,
               libboost-dev,
               libboost-iostreams-dev,
               libboost-python-dev,
               libboost-regex-dev,
               libboost-system-dev,
               libboost-thread-dev,
               libcairo-dev,
               libcoordgen-dev,
               libeigen3-dev,
               libfreetype6-dev,
               libmaeparser-dev,
               librsvg2-bin,
               libsqlite3-dev,
               pandoc,
               postgresql-server-dev-all,
               python3-dev,
               python3-numpy,
               python3-pandas,
               python3-pil | python3-imaging,
               python3-recommonmark,
               python3-sphinx,
               python3-sqlalchemy,
               rapidjson-dev,
               tex-gyre,
               texlive-fonts-recommended,
               texlive-latex-base,
               texlive-latex-extra,
               texlive-latex-recommended
Standards-Version: 4.2.1
Vcs-Browser: https://salsa.debian.org/debichem-team/rdkit
Vcs-Git: https://salsa.debian.org/debichem-team/rdkit.git
Homepage: http://www.rdkit.org

Package: python3-rdkit
Section: python
Architecture: any
Depends: fonts-freefont-ttf,
         rdkit-data,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Suggests: rdkit-doc
Provides: ${python3:Provides}
XB-Python-Version: ${python3:Versions}
Description: Collection of cheminformatics and machine-learning software
 RDKit is a Python/C++ based cheminformatics and machine-learning software
 environment.  Features Include:
 .
  * Chemical reaction handling and transforms
  * Substructure searching with SMARTS
  * Canonical SMILES
  * Molecule-molecule alignment
  * Large number of molecular descriptors, including topological,
    compositional, EState, SlogP/SMR, VSA and Feature-map vectors
  * Fragmentation using RECAP rules
  * 2D coordinate generation and depiction, including constrained depiction
  * 3D coordinate generation using geometry embedding
  * UFF and MMFF94 forcefields
  * Chirality support, including calculation of (R/S) stereochemistry codes
  * 2D pharmacophore searching
  * Fingerprinting, including Daylight-like, atom pairs, topological
    torsions, Morgan algorithm and MACCS keys
  * Calculation of shape similarity
  * Multi-molecule maximum common substructure
  * Machine-learning via clustering and information theory algorithms
  * Gasteiger-Marsili partial charge calculation
 .
 File formats RDKit supports include MDL Mol, PDB, SDF, TDT, SMILES and RDKit
 binary format.

Package: rdkit-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Collection of cheminformatics and machine-learning software (documentation)
 RDKit is a Python/C++ based cheminformatics and machine-learning software
 environment.
 .
 This package contains the documentation.

Package: rdkit-data
Architecture: all
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Collection of cheminformatics and machine-learning software (data files)
 RDKit is a Python/C++ based cheminformatics and machine-learning software
 environment.
 .
 This package contains data files.

Package: librdkit1
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Collection of cheminformatics and machine-learning software (shared libraries)
 RDKit is a Python/C++ based cheminformatics and machine-learning software
 environment.  Features Include:
 .
  * Chemical reaction handling and transforms
  * Substructure searching with SMARTS
  * Canonical SMILES
  * Molecule-molecule alignment
  * Large number of molecular descriptors, including topological,
    compositional, EState, SlogP/SMR, VSA and Feature-map vectors
  * Fragmentation using RECAP rules
  * 2D coordinate generation and depiction, including constrained depiction
  * 3D coordinate generation using geometry embedding
  * UFF and MMFF94 forcefields
  * Chirality support, including calculation of (R/S) stereochemistry codes
  * 2D pharmacophore searching
  * Fingerprinting, including Daylight-like, atom pairs, topological
    torsions, Morgan algorithm and MACCS keys
  * Calculation of shape similarity
  * Multi-molecule maximum common substructure
  * Machine-learning via clustering and information theory algorithms
  * Gasteiger-Marsili partial charge calculation
 .
 File formats RDKit supports include MDL Mol, PDB, SDF, TDT, SMILES and RDKit
 binary format.
 .
 This package contains the shared libraries.

Package: librdkit-dev
Section: libdevel
Architecture: any
Depends: librdkit1 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Collection of cheminformatics and machine-learning software (development files)
 RDKit is a Python/C++ based cheminformatics and machine-learning software
 environment.  Features Include:
 .
  * Chemical reaction handling and transforms
  * Substructure searching with SMARTS
  * Canonical SMILES
  * Molecule-molecule alignment
  * Large number of molecular descriptors, including topological,
    compositional, EState, SlogP/SMR, VSA and Feature-map vectors
  * Fragmentation using RECAP rules
  * 2D coordinate generation and depiction, including constrained depiction
  * 3D coordinate generation using geometry embedding
  * UFF and MMFF94 forcefields
  * Chirality support, including calculation of (R/S) stereochemistry codes
  * 2D pharmacophore searching
  * Fingerprinting, including Daylight-like, atom pairs, topological
    torsions, Morgan algorithm and MACCS keys
  * Calculation of shape similarity
  * Multi-molecule maximum common substructure
  * Machine-learning via clustering and information theory algorithms
  * Gasteiger-Marsili partial charge calculation
 .
 File formats RDKit supports include MDL Mol, PDB, SDF, TDT, SMILES and RDKit
 binary format.
 .
 This package contains the header files.

Package: postgresql-10-rdkit
Architecture: any
Section: database
Depends: ${misc:Depends}, ${shlibs:Depends}, postgresql-10
Suggests:
Description: Cheminformatics and machine-learning software (PostgreSQL Cartridge)
 RDKit is a Python/C++ based cheminformatics and machine-learning software
 environment.  Features Include:
 .
  * Chemical reaction handling and transforms
  * Substructure searching with SMARTS
  * Canonical SMILES
  * Molecule-molecule alignment
  * Large number of molecular descriptors, including topological,
    compositional, EState, SlogP/SMR, VSA and Feature-map vectors
  * Fragmentation using RECAP rules
  * 2D coordinate generation and depiction, including constrained depiction
  * 3D coordinate generation using geometry embedding
  * UFF and MMFF94 forcefields
  * Chirality support, including calculation of (R/S) stereochemistry codes
  * 2D pharmacophore searching
  * Fingerprinting, including Daylight-like, atom pairs, topological
    torsions, Morgan algorithm and MACCS keys
  * Calculation of shape similarity
  * Multi-molecule maximum common substructure
  * Machine-learning via clustering and information theory algorithms
  * Gasteiger-Marsili partial charge calculation
 .
 File formats RDKit supports include MDL Mol, PDB, SDF, TDT, SMILES and RDKit
 binary format.
 .
 This package contains the PostgreSQL extension.

Package: postgresql-11-rdkit
Architecture: any
Section: database
Depends: ${misc:Depends}, ${shlibs:Depends}, postgresql-11
Suggests:
Description: Cheminformatics and machine-learning software (PostgreSQL Cartridge)
 RDKit is a Python/C++ based cheminformatics and machine-learning software
 environment.  Features Include:
 .
  * Chemical reaction handling and transforms
  * Substructure searching with SMARTS
  * Canonical SMILES
  * Molecule-molecule alignment
  * Large number of molecular descriptors, including topological,
    compositional, EState, SlogP/SMR, VSA and Feature-map vectors
  * Fragmentation using RECAP rules
  * 2D coordinate generation and depiction, including constrained depiction
  * 3D coordinate generation using geometry embedding
  * UFF and MMFF94 forcefields
  * Chirality support, including calculation of (R/S) stereochemistry codes
  * 2D pharmacophore searching
  * Fingerprinting, including Daylight-like, atom pairs, topological
    torsions, Morgan algorithm and MACCS keys
  * Calculation of shape similarity
  * Multi-molecule maximum common substructure
  * Machine-learning via clustering and information theory algorithms
  * Gasteiger-Marsili partial charge calculation
 .
 File formats RDKit supports include MDL Mol, PDB, SDF, TDT, SMILES and RDKit
 binary format.
 .
 This package contains the PostgreSQL extension.

Package: postgresql-12-rdkit
Architecture: any
Section: database
Depends: ${misc:Depends}, ${shlibs:Depends}, postgresql-12
Suggests:
Description: Cheminformatics and machine-learning software (PostgreSQL Cartridge)
 RDKit is a Python/C++ based cheminformatics and machine-learning software
 environment.  Features Include:
 .
  * Chemical reaction handling and transforms
  * Substructure searching with SMARTS
  * Canonical SMILES
  * Molecule-molecule alignment
  * Large number of molecular descriptors, including topological,
    compositional, EState, SlogP/SMR, VSA and Feature-map vectors
  * Fragmentation using RECAP rules
  * 2D coordinate generation and depiction, including constrained depiction
  * 3D coordinate generation using geometry embedding
  * UFF and MMFF94 forcefields
  * Chirality support, including calculation of (R/S) stereochemistry codes
  * 2D pharmacophore searching
  * Fingerprinting, including Daylight-like, atom pairs, topological
    torsions, Morgan algorithm and MACCS keys
  * Calculation of shape similarity
  * Multi-molecule maximum common substructure
  * Machine-learning via clustering and information theory algorithms
  * Gasteiger-Marsili partial charge calculation
 .
 File formats RDKit supports include MDL Mol, PDB, SDF, TDT, SMILES and RDKit
 binary format.
 .
 This package contains the PostgreSQL extension.

Package: postgresql-13-rdkit
Architecture: any
Section: database
Depends: ${misc:Depends}, ${shlibs:Depends}, postgresql-13
Suggests:
Description: Cheminformatics and machine-learning software (PostgreSQL Cartridge)
 RDKit is a Python/C++ based cheminformatics and machine-learning software
 environment.  Features Include:
 .
  * Chemical reaction handling and transforms
  * Substructure searching with SMARTS
  * Canonical SMILES
  * Molecule-molecule alignment
  * Large number of molecular descriptors, including topological,
    compositional, EState, SlogP/SMR, VSA and Feature-map vectors
  * Fragmentation using RECAP rules
  * 2D coordinate generation and depiction, including constrained depiction
  * 3D coordinate generation using geometry embedding
  * UFF and MMFF94 forcefields
  * Chirality support, including calculation of (R/S) stereochemistry codes
  * 2D pharmacophore searching
  * Fingerprinting, including Daylight-like, atom pairs, topological
    torsions, Morgan algorithm and MACCS keys
  * Calculation of shape similarity
  * Multi-molecule maximum common substructure
  * Machine-learning via clustering and information theory algorithms
  * Gasteiger-Marsili partial charge calculation
 .
 File formats RDKit supports include MDL Mol, PDB, SDF, TDT, SMILES and RDKit
 binary format.
 .
 This package contains the PostgreSQL extension.

Package: postgresql-14-rdkit
Architecture: any
Section: database
Depends: ${misc:Depends}, ${shlibs:Depends}, postgresql-14
Suggests:
Description: Cheminformatics and machine-learning software (PostgreSQL Cartridge)
